//
// Copyright (c) 2005-2011 StreamBase Systems, Inc. All rights reserved.
//
package com.streambase.sb.contrib.adapter.sbmonitor;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;
import com.streambase.sb.Timestamp;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;
import com.streambase.sb.monitor.OperatorInfo;

public class OperatorInfoSchemaHelper {

	public static final String TIME="time";
	public static final String NAME="operatorName";
	public static final String SIZE="size";
	public static final String PERCENTUSAGE="percentUsage";
	public static final String PROFILERMSDELTA="profilerMSDelta";
	public static final String INTPS="inTPS";
	public static final String OUTTPS="outTPS";
	
	public static final Schema.Field[] FIELDS = {
		
		new Schema.Field(TIME, CompleteDataType.forTimestamp()),
		new Schema.Field(NAME, CompleteDataType.forString()),
		new Schema.Field(SIZE, CompleteDataType.forInt()),
        new Schema.Field(PERCENTUSAGE, CompleteDataType.forDouble()),
        new Schema.Field(PROFILERMSDELTA, CompleteDataType.forLong()),
        new Schema.Field(INTPS, CompleteDataType.forInt()),
        new Schema.Field(OUTTPS, CompleteDataType.forInt())	};
	
	public static Schema SCHEMA=new Schema(null, FIELDS);
	
	public static final int IDX_FIELD_TIME = SCHEMA.getFieldIndex(TIME);
	public static final int IDX_FIELD_NAME = SCHEMA.getFieldIndex(NAME);
	public static final int IDX_FIELD_SIZE = SCHEMA.getFieldIndex(SIZE);
	public static final int IDX_FIELD_PERCENTUSAGE = SCHEMA.getFieldIndex(PERCENTUSAGE);
	public static final int IDX_FIELD_PROFILERMSDELTA = SCHEMA.getFieldIndex(PROFILERMSDELTA);
	public static final int IDX_FIELD_INTPS = SCHEMA.getFieldIndex(INTPS);
	public static final int IDX_FIELD_OUTTPS = SCHEMA.getFieldIndex(OUTTPS);
	
	
	public static Tuple createTuple() {
		return SCHEMA.createTuple();
	}
	
	public static Tuple createOperatorTuple(Timestamp ts, OperatorInfo op) throws TupleException {
		Tuple tuple = createTuple();
		tuple.clear();
		
		tuple.setTimestamp(IDX_FIELD_TIME, ts);
		tuple.setString(IDX_FIELD_NAME, op.getName());
		tuple.setInt(IDX_FIELD_SIZE, op.getSize());
		tuple.setDouble(IDX_FIELD_PERCENTUSAGE, op.getPercentUsage());
		tuple.setLong(IDX_FIELD_PROFILERMSDELTA, op.getProfilerMSDelta());
		tuple.setInt(IDX_FIELD_INTPS, op.getInputTuplesEnqueuedDelta());
		tuple.setInt(IDX_FIELD_OUTTPS, op.getOutputTuplesEnqueuedDelta());
		
		return tuple;

	}
}
