//
// Copyright (c) 2005-2011 StreamBase Systems, Inc. All rights reserved.
//
package com.streambase.sb.contrib.adapter.sbmonitor;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;
import com.streambase.sb.Timestamp;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;
import com.streambase.sb.monitor.StreamInfo;

public class StreamInfoSchemaHelper {
	public static final String TIME="time";
	public static final String NAME="streamName";
	public static final String DELTATUPLES="deltaTuples";

	
	public static final Schema.Field[] FIELDS = {
		
		new Schema.Field(TIME, CompleteDataType.forTimestamp()),
		new Schema.Field(NAME, CompleteDataType.forString()),
        new Schema.Field(DELTATUPLES, CompleteDataType.forLong()),
	};
	
	public static Schema SCHEMA=new Schema(null, FIELDS);
	
	public static final int IDX_FIELD_TIME = SCHEMA.getFieldIndex(TIME);
	public static final int IDX_FIELD_NAME = SCHEMA.getFieldIndex(NAME);
	public static final int IDX_FIELD_DELTATUPLES = SCHEMA.getFieldIndex(DELTATUPLES);
	
	public static Tuple createTuple() {
		return SCHEMA.createTuple();
	}
	
	public static Tuple createStreamTuple(Timestamp ts, StreamInfo st) throws TupleException {
		Tuple tuple = createTuple();
		tuple.clear();
		
		tuple.setTimestamp(IDX_FIELD_TIME, ts);
		tuple.setString(IDX_FIELD_NAME, st.getStreamProperties().getQualifiedName());
		tuple.setLong(IDX_FIELD_DELTATUPLES, st.getDeltaTuples());

		return tuple;

	}
}
