//
// Copyright (c) 2005-2011 StreamBase Systems, Inc. All rights reserved.
//
package com.streambase.sb.contrib.adapter.sbmonitor;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.Schema;
import com.streambase.sb.Timestamp;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;
import com.streambase.sb.monitor.ThreadInfo;

public class ThreadInfoSchemaHelper {
	public static final String TIME="time";
	public static final String NAME="threadName";
	public static final String USERTIME="userTime";
	public static final String SYSTEMTIME="systemTime";
	
	public static final Schema.Field[] FIELDS = {
		
		new Schema.Field(TIME, CompleteDataType.forTimestamp()),
		new Schema.Field(NAME, CompleteDataType.forString()),
        new Schema.Field(USERTIME, CompleteDataType.forLong()),
        new Schema.Field(SYSTEMTIME, CompleteDataType.forLong())
	};
	
	public static Schema SCHEMA=new Schema(null, FIELDS);
	
	public static final int IDX_FIELD_TIME = SCHEMA.getFieldIndex(TIME);
	public static final int IDX_FIELD_NAME = SCHEMA.getFieldIndex(NAME);
	public static final int IDX_FIELD_USERTIME = SCHEMA.getFieldIndex(USERTIME);
	public static final int IDX_FIELD_SYSTEMTIME = SCHEMA.getFieldIndex(SYSTEMTIME);

	
	public static Tuple createTuple() {
		return SCHEMA.createTuple();
	}
	
	public static Tuple createThreadTuple(Timestamp ts, ThreadInfo th) throws TupleException {
		Tuple tuple = createTuple();
		tuple.clear();
		
		tuple.setTimestamp(IDX_FIELD_TIME, ts);
		tuple.setString(IDX_FIELD_NAME, th.getName());
		tuple.setLong(IDX_FIELD_USERTIME, th.getUserTimeDelta());
		tuple.setLong(IDX_FIELD_SYSTEMTIME, th.getSystemTimeDelta());

		return tuple;

	}
}
